Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/ExperimentController.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/ExperimentController.cs	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/ExperimentController.cs	(revision 9215)
@@ -0,0 +1,97 @@
+﻿using System; 
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+using System.Web.Mvc;
+using HeuristicLab.Services.Optimization.Web.Models;
+using HeuristicLab.Services.Optimization.Web.Helpers;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+using System.Web.Security;
+
+namespace HeuristicLab.Services.Optimization.Web.Controllers
+{
+    [Authorize(Roles = "Web User")]
+    public class ExperimentController : Controller
+    {
+        private ControllerServiceHelper ControllerService {
+          get {
+            var helper = new ControllerServiceHelper(Session["pw"] as string);
+            if (!helper.Valid) {
+              Response.Redirect("/Account/Logon?ReturnUrl=%2fExperiment");
+            }
+            return helper;
+          }
+        }
+
+        //
+        // GET: /Experiment/
+
+        public ActionResult Index()
+        {
+          var model = new ExperimentViewModel();
+          var scenarios = ControllerService.withControllerService<IEnumerable<string>>((service) => {
+            return service.GetOptimizationScenarioNames();
+          });
+          var experiments = ControllerService.withControllerService<IEnumerable<string>>((service) => {
+            User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+            return service.GetExperiments(u);
+          });
+          foreach (var experiment in experiments)
+            model.Experiments.Add(experiment);
+          foreach (var scenario in scenarios)
+            model.Scenarios.Add(scenario);
+          return View(model);
+        }
+
+        [HttpPost]
+        public JsonResult Save(ExperimentModel model) {
+          var experiment = new Experiment() { Name = model.Name };
+          var stack = new Stack<Node>();
+
+          foreach (var node in model.Experiment.children)
+            stack.Push(node);
+
+          while (stack.Count > 0) {
+            var currentNode = stack.Pop();
+            // add children to stack
+            if (currentNode.children != null)
+              foreach (var node in currentNode.children)
+                stack.Push(node);
+
+            // TODO: Do we really need a tree of scenarios? Or is it a simple list?
+            // push currentNode to experiment
+            if (currentNode.title == "Experiment")
+              continue;
+            experiment.Scenarios.Add(new OptimizationScenario() { Id = currentNode.title });
+          }
+
+          var ok = ControllerService.withControllerService<bool>((service) => {
+            User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+            return service.SaveExperiment(u, experiment);
+          });
+
+          if (ok)
+            return Json(new { success = true, data = model.Name });
+          return Json(new { success = false, error = "Experiment already exists!" });
+        }
+
+        public ActionResult Edit() {
+          var model = new ExperimentViewModel();
+          var experiments = ControllerService.withControllerService<IEnumerable<string>>((service) => {
+            User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+            return service.GetExperiments(u);
+          });
+          foreach (var experiment in experiments)
+            model.Experiments.Add(experiment);
+          return View(model);
+        }
+
+        public ActionResult DeleteExperiment(string experiment) {
+          ControllerService.withControllerService<bool>((service) => {
+            User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+            return service.DeleteExperiment(u, experiment);
+          });
+          return RedirectToAction("Edit");
+        }
+    }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/OptimizationController.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/OptimizationController.cs	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/OptimizationController.cs	(revision 9215)
@@ -11,4 +11,5 @@
 using HeuristicLab.Services.Optimization.Web.Models;
 using HeuristicLab.Services.Optimization.ControllerService.General;
+using HeuristicLab.Services.Optimization.Web.Helpers;
 
 namespace HeuristicLab.Services.Optimization.Web.Controllers
@@ -16,41 +17,20 @@
     [Authorize(Roles="Web User")]
     public class OptimizationController : Controller
-    {
-      public static readonly string DEFAULT_CONTROLLER_ENDPOINT = Configuration.ControllerEndpointName;
+    {     
+        private ControllerServiceHelper ControllerService {
+          get {
+            var helper = new ControllerServiceHelper(Session["pw"] as string);
+            if (!helper.Valid) {
+              Response.Redirect("/Account/Logon?ReturnUrl=%2fOptimization");
+            }
+            return helper;
+          }
+        }
 
-      public delegate T ControllerServiceDelegate<T>(IControllerService service);
-      public delegate void ControllerServiceDelegate(IControllerService service);
-
-      public T withControllerService<T>(ControllerServiceDelegate<T> del) {
-        if (Session["pw"] == null)
-          Response.Redirect("/Account/Logon");
-
-        using (var cf = new ChannelFactory<IControllerService>(DEFAULT_CONTROLLER_ENDPOINT)) {
-          var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
-          credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
-          credentialBehaviour.UserName.Password = Session["pw"] as string;
-          var controllerProxy = cf.CreateChannel();
-          return del(controllerProxy);
-        }
-      }
-
-      public void withControllerService(ControllerServiceDelegate del) {
-        if (Session["pw"] == null)
-          Response.Redirect("/Account/Logon");
-
-        using (var cf = new ChannelFactory<IControllerService>(DEFAULT_CONTROLLER_ENDPOINT)) {          
-          var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
-          credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
-          credentialBehaviour.UserName.Password = Session["pw"] as string;          
-          var controllerProxy = cf.CreateChannel();
-          del(controllerProxy);
-        }
-      }
         //
-        // GET: /Optimization/        
-
+        // GET: /Optimization/   
         public ActionResult Index()
         {
-          var optModel = withControllerService<OptimizationModel>((service) => {
+          var optModel = ControllerService.withControllerService<OptimizationModel>((service) => {
             OptimizationModel model = new OptimizationModel();
             model.Scenarios = service.GetOptimizationScenarios();
@@ -58,10 +38,10 @@
             model.Jobs = service.GetJobs(u);
             return model;
-          });
+          });          
           return View(optModel);
         }
 
         public ActionResult ProblemParameters(string scenario) {
-          var optScenario = withControllerService<OptimizationScenario>((service) => {
+          var optScenario = ControllerService.withControllerService<OptimizationScenario>((service) => {
             return service.GetOptimizationScenarioByName(scenario);
           });
@@ -77,9 +57,9 @@
 
         public ActionResult JobDetails(string jobId) {
-          Job job = withControllerService<Job>((service) => {
+          Job job = ControllerService.withControllerService<Job>((service) => {
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
             return service.GetJob(u, jobId);
           });
-          var runs = withControllerService<IList<Run>>((service) => {
+          var runs = ControllerService.withControllerService<IList<Run>>((service) => {
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
             return service.GetJobResults(u, jobId);
@@ -92,7 +72,7 @@
         [HttpPost]
         public ActionResult JobDetails(Job job) {
-          withControllerService((service) => {
+          ControllerService.withControllerService<bool>((service) => {
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
-            service.DeleteJob(u, job.Id);
+            return service.DeleteJob(u, job.Id);
           });
           return RedirectToAction("Index");
@@ -125,14 +105,10 @@
         [HttpPost]
         public ActionResult ScheduleJob(ScheduleJobModel jobModel) {
-          using (var cf = new ChannelFactory<IControllerService>(OptimizationController.DEFAULT_CONTROLLER_ENDPOINT)) {
-            var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
-            credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;
-            credentialBehaviour.UserName.Password = Session["pw"] as string;
-            var controllerProxy = cf.CreateChannel();
+          var success = ControllerService.withControllerService<bool>((service) => {
             User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
             var scenario = Session["scenario"] as OptimizationScenario;
             var details = new JobExecutionDetails() { Group = jobModel.Group, JobTitle = jobModel.Name, Repititions = jobModel.Repetitions };
-            controllerProxy.ScheduleOptimizationScenario(u, scenario, details);
-          }
+            return service.ScheduleOptimizationScenario(u, scenario, details);
+          });
           return RedirectToAction("Index");
         }
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/StatusController.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/StatusController.cs	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Controllers/StatusController.cs	(revision 9215)
@@ -0,0 +1,56 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+using System.Web.Mvc;
+using HeuristicLab.Services.Optimization.Web.Models;
+using HeuristicLab.Services.Optimization.Web.Helpers;
+using System.Web.Security;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+
+namespace HeuristicLab.Services.Optimization.Web.Controllers
+{
+  public class StatusController : Controller {
+    private ControllerServiceHelper ControllerService {
+      get {
+        var helper = new ControllerServiceHelper(Session["pw"] as string);
+        if (!helper.Valid) {
+          Response.Redirect("/Account/Logon?ReturnUrl=%2fStatus");
+        }
+        return helper;
+      }
+    }
+
+    //
+    // GET: /Status/
+
+    public ActionResult Index() {
+      var statModel = ControllerService.withControllerService<StatusModel>((service) => {
+        var model = new StatusModel();
+        User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+        model.Jobs = service.GetJobs(u).ToList();
+        return model;
+      });
+      return View(statModel);
+    }
+
+    [HttpGet]
+    public JsonResult GetTasks(string jobId) {      
+      var job = ControllerService.withControllerService<Job>((service) => {        
+        User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };        
+        return service.GetTasks(u, jobId);
+      });
+
+      return Json(job, JsonRequestBehavior.AllowGet);
+    }
+
+    [HttpGet]
+    public JsonResult GetTaskData(string jobId, string taskId) {
+      var t1 = ControllerService.withControllerService<Task>((service) => {
+        User u = new User() { Username = Membership.GetUser().UserName, Password = Session["pw"] as string };
+        return service.GetTaskData(u, jobId, taskId);
+      });
+      return Json(t1, JsonRequestBehavior.AllowGet);
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Helpers/ControllerService.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Helpers/ControllerService.cs	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Helpers/ControllerService.cs	(revision 9215)
@@ -0,0 +1,41 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+using System.Web.Mvc;
+using HeuristicLab.Services.Optimization.ControllerService.General;
+using HeuristicLab.Services.Optimization.ControllerService;
+using System.ServiceModel;
+using System.Web.Security;
+using System.ServiceModel.Description;
+
+namespace HeuristicLab.Services.Optimization.Web.Helpers
+{
+    public class ControllerServiceHelper
+    {
+      public static readonly string DEFAULT_CONTROLLER_ENDPOINT = Configuration.ControllerEndpointName;
+
+      public delegate T ControllerServiceDelegate<T>(IControllerService service);
+      
+      private string pw;
+
+      public ControllerServiceHelper(string pw) { 
+        this.pw = pw;
+      }
+
+      public bool Valid { get { return pw != null; } }
+
+      public T withControllerService<T>(ControllerServiceDelegate<T> del) {
+        if (!Valid)
+          return default(T);
+
+        using (var cf = new ChannelFactory<IControllerService>(DEFAULT_CONTROLLER_ENDPOINT)) {
+          var credentialBehaviour = cf.Endpoint.Behaviors.Find<ClientCredentials>();
+          credentialBehaviour.UserName.UserName = Membership.GetUser().UserName;          
+          credentialBehaviour.UserName.Password = pw;
+          var controllerProxy = cf.CreateChannel();
+          return del(controllerProxy);
+        }
+      }
+    }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/HeuristicLab.Services.Optimization.Web.csproj	(revision 9215)
@@ -97,17 +97,30 @@
   </ItemGroup>
   <ItemGroup>
+    <Content Include="Content\dynatree\dist\jquery.dynatree.min.js" />
+    <Content Include="Content\dynatree\src\skin\icons-rtl.gif" />
+    <Content Include="Content\dynatree\src\skin\icons.gif" />
+    <Content Include="Content\dynatree\src\skin\loading.gif" />
+    <Content Include="Content\dynatree\src\skin\ui.dynatree.css" />
+    <Content Include="Content\dynatree\src\skin\vline-rtl.gif" />
+    <Content Include="Content\dynatree\src\skin\vline.gif" />
+    <Content Include="Content\ExperimentSupport.js" />
     <Compile Include="Controllers\AccountController.cs" />
     <Compile Include="Controllers\AdminController.cs" />
     <Compile Include="Controllers\ChartController.cs" />
+    <Compile Include="Controllers\ExperimentController.cs" />
     <Compile Include="Controllers\HomeController.cs" />
     <Compile Include="Controllers\OptimizationController.cs" />
+    <Compile Include="Controllers\StatusController.cs" />
     <Compile Include="Global.asax.cs">
       <DependentUpon>Global.asax</DependentUpon>
     </Compile>
+    <Compile Include="Helpers\ControllerService.cs" />
     <Compile Include="Mockup\MockupMembershipProvider.cs" />
     <Compile Include="Models\AccountModels.cs" />
     <Compile Include="Models\AdminModels.cs" />
     <Compile Include="Models\ChartModels.cs" />
+    <Compile Include="Models\ExperimentModel.cs" />
     <Compile Include="Models\OptimizationModels.cs" />
+    <Compile Include="Models\StatusModel.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="WebRole.cs" />
@@ -131,4 +144,5 @@
     <Content Include="Content\datatable\images\sort_desc.png" />
     <Content Include="Content\datatable\images\sort_desc_disabled.png" />
+    <Content Include="Content\hl\images\ajax-loader.gif" />
     <Content Include="Content\jqplot\src\changes.txt" />
     <Content Include="Content\jqplot\src\excanvas.js" />
@@ -273,4 +287,42 @@
     <Content Include="Scripts\modernizr-1.7.js" />
     <Content Include="Scripts\modernizr-1.7.min.js" />
+    <Content Include="Views\Account\ChangePassword.cshtml" />
+    <Content Include="Views\Account\ChangePasswordSuccess.cshtml" />
+    <Content Include="Views\Account\LogOn.cshtml" />
+    <Content Include="Views\Account\Register.cshtml" />
+    <Content Include="Views\Admin\Index.cshtml" />
+    <Content Include="Views\Chart\GenerateChart.cshtml" />
+    <Content Include="Views\Experiment\Edit.cshtml" />
+    <Content Include="Views\Experiment\Index.cshtml" />
+    <Content Include="Views\Home\About.cshtml" />
+    <Content Include="Views\Home\Index.cshtml" />
+    <Content Include="Views\Optimization\AlgorithmParameters.cshtml" />
+    <Content Include="Views\Optimization\Copy of JobDetails.cshtml" />
+    <Content Include="Views\Optimization\Index.cshtml">
+      <SubType>Code</SubType>
+    </Content>
+    <Content Include="Views\Optimization\JobDetails.cshtml" />
+    <Content Include="Views\Optimization\ProblemParameters.cshtml" />
+    <Content Include="Views\Optimization\ScheduleJob.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\AlgorithmParameters.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\BoolValue.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\DecimalMatrix.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\DecimalValue.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\DecimalVector.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\ProblemParameters.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\StringValue.cshtml" />
+    <Content Include="Views\Shared\DisplayTemplates\TypeValue.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\AlgorithmParameters.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\BoolValue.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\DecimalMatrix.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\DecimalValue.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\DecimalVector.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\ProblemParameters.cshtml" />
+    <Content Include="Views\Shared\EditorTemplates\TypeValue.cshtml" />
+    <Content Include="Views\Shared\Error.cshtml" />
+    <Content Include="Views\Shared\_Layout.cshtml" />
+    <Content Include="Views\Shared\_LogOnPartial.cshtml" />
+    <Content Include="Views\Web.config" />
+    <Content Include="Views\_ViewStart.cshtml" />
     <Content Include="Web.config">
       <SubType>Designer</SubType>
@@ -293,15 +345,4 @@
     <Content Include="Scripts\MicrosoftMvcValidation.js" />
     <Content Include="Scripts\MicrosoftMvcValidation.debug.js" />
-    <Content Include="Views\_ViewStart.cshtml" />
-    <Content Include="Views\Account\ChangePassword.cshtml" />
-    <Content Include="Views\Account\ChangePasswordSuccess.cshtml" />
-    <Content Include="Views\Account\LogOn.cshtml" />
-    <Content Include="Views\Account\Register.cshtml" />
-    <Content Include="Views\Home\About.cshtml" />
-    <Content Include="Views\Home\Index.cshtml" />
-    <Content Include="Views\Shared\Error.cshtml" />
-    <Content Include="Views\Shared\_LogOnPartial.cshtml" />
-    <Content Include="Views\Shared\_Layout.cshtml" />
-    <Content Include="Views\Web.config" />
   </ItemGroup>
   <ItemGroup>
@@ -310,7 +351,4 @@
   <ItemGroup>
     <Content Include="packages.config" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Optimization\Index.cshtml" />
   </ItemGroup>
   <ItemGroup>
@@ -321,59 +359,5 @@
   </ItemGroup>
   <ItemGroup>
-    <Content Include="Views\Optimization\ProblemParameters.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Optimization\AlgorithmParameters.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Optimization\ScheduleJob.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\ProblemParameters.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\DecimalValue.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\BoolValue.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\TypeValue.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\DecimalMatrix.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\DecimalVector.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\EditorTemplates\AlgorithmParameters.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\AlgorithmParameters.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\TypeValue.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\BoolValue.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\DecimalMatrix.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\DecimalValue.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\DecimalVector.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Shared\DisplayTemplates\ProblemParameters.cshtml" />
-  </ItemGroup>
-  <ItemGroup>
     <Content Include="HeuristicLab 3.3.exe.config" />
-  </ItemGroup>
-  <ItemGroup>
-    <Content Include="Views\Optimization\JobDetails.cshtml" />
   </ItemGroup>
   <ItemGroup>
@@ -384,8 +368,5 @@
       <SubType>Designer</SubType>
     </None>
-    <Content Include="Views\Admin\Index.cshtml" />
-    <Content Include="Views\Chart\GenerateChart.cshtml" />
-    <Content Include="Views\Optimization\Copy of JobDetails.cshtml" />
-    <Content Include="Views\Shared\DisplayTemplates\StringValue.cshtml" />
+    <Content Include="Views\Status\Index.cshtml" />
   </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/ExperimentModel.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/ExperimentModel.cs	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/ExperimentModel.cs	(revision 9215)
@@ -0,0 +1,41 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+
+namespace HeuristicLab.Services.Optimization.Web.Models {
+  public class Node {
+    public string title { get; set; }
+    public List<Node> children { get; set; }
+
+    public string GetTitle { get { return title; } }
+    public List<Node> GetChildren { get { return children; } }
+  }
+
+  public class ExperimentModel {
+    public Node Experiment { get; set; }
+    public string Name { get; set; }
+  }
+
+  public class ExperimentViewModel {
+    private IList<string> scenarios;
+
+    public IList<string> Scenarios {
+      get { return scenarios; }
+      set { scenarios = value; }
+    }
+
+    private IList<string> experiments;
+
+    public IList<string> Experiments {
+      get { return experiments; }
+      set { experiments = value; }
+    }
+
+    public ExperimentViewModel() {
+      experiments = new List<string>();
+      scenarios = new List<string>();
+    }
+
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/StatusModel.cs
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/StatusModel.cs	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Models/StatusModel.cs	(revision 9215)
@@ -0,0 +1,27 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+using HeuristicLab.Services.Optimization.ControllerService.Model;
+
+namespace HeuristicLab.Services.Optimization.Web.Models {
+  /*public class Job {
+    public string Id { get; set; }
+    private IList<Task> tasks = new List<Task>();
+
+    public IList<Task> Tasks {
+      get { return tasks; }
+      set { tasks = value; }
+    }
+  }*/
+
+  public class StatusModel {
+    // Jobs
+    private IList<Job> jobs = new List<Job>();
+
+    public IList<Job> Jobs {
+      get { return jobs; }
+      set { jobs = value; }
+    }
+  }
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Account/LogOn.cshtml
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Account/LogOn.cshtml	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Account/LogOn.cshtml	(revision 9215)
@@ -14,6 +14,5 @@
 
 @Html.ValidationSummary(true, "Login was unsuccessful. Please correct the errors and try again.")
-
-@using (Html.BeginForm("LogOn", "Account", FormMethod.Post, new { @class = "hl-signon-form" })) {
+@using (Html.BeginForm("LogOn", "Account", new { ReturnUrl = Request.QueryString["ReturnUrl"] }, FormMethod.Post, new { @class ="hl-signon-form" })) {
         <fieldset>
             <legend>Account Information</legend>
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Experiment/Edit.cshtml
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Experiment/Edit.cshtml	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Experiment/Edit.cshtml	(revision 9215)
@@ -0,0 +1,21 @@
+﻿@model HeuristicLab.Services.Optimization.Web.Models.ExperimentViewModel
+
+@{
+    ViewBag.Title = "Edit";
+}
+
+<h2>Edit your experiments</h2>
+
+<ul>
+@foreach (var exp in Model.Experiments) {
+   <li>@Html.ActionLink("Delete " + exp, "DeleteExperiment", new { experiment = exp })</li>
+}
+</ul>
+
+@section submenu {
+    <ul>
+        <li>@Html.ActionLink("Build", "Index")</li>    
+        <li class="selected">@Html.ActionLink("Edit", "Edit")</li>
+        <li>@Html.ActionLink("Status", "Index", "Status")</li>
+    </ul>
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Experiment/Index.cshtml
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Experiment/Index.cshtml	(revision 9215)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Experiment/Index.cshtml	(revision 9215)
@@ -0,0 +1,66 @@
+﻿@model HeuristicLab.Services.Optimization.Web.Models.ExperimentViewModel
+
+@{
+    ViewBag.Title = "Experiments";
+}
+
+<h2>Build your experiment:</h2>
+@using (Html.BeginForm("SaveExperiment", "Experiment"))
+{
+  <fieldset>
+    <legend>Create Template Experiment:</legend>
+    
+    <div class="editor-label">
+      <label for="name">Experiment Template Name:</label>
+    </div>
+
+    <div class="editor-field">
+      <input id="name" name="Name" type="text" value="My Experiment" />
+    </div>
+
+    <div>
+    <p>Experiment Tree:</p>
+    </div>
+
+    <div id="container" class="treeStyle">
+      <ul>
+        <li id="root">Experiment</li>
+      </ul>
+    </div>
+    <input style="margin-top:5px;"  name="RemoveNode" type="button" value="Remove" disabled="disabled" />
+
+    <div id="scenarios">
+    @if (Model.Scenarios.Count > 0) {
+        <p>Choose an algorithm:</p>
+        foreach (var scen in Model.Scenarios) {
+            <div class="dragables" id="@scen"><p>@scen</p></div>
+        }        
+        
+    }
+        <div class="clearer"/>
+    </div>
+    
+    <div id="experiments">
+    @if (Model.Scenarios.Count > 0) {
+        <p>Choose from your stored experiments:</p>
+        foreach (var scen in Model.Experiments) {
+            <div class="dragables" id="@scen"><p>@scen</p></div>
+        }       
+        
+    }   
+        <div class="clearer"/> 
+    </div>
+    <input type="submit" value="Save experiment" class="submitter" />
+    <img src="@Url.Content("~/Content/hl/images/ajax-loader.gif")" alt="Loading animation" class="loader unseen" />
+  </fieldset>
+    <div><p id="jsonMessage"></p></div>
+}
+
+
+@section submenu {
+    <ul>
+        <li class="selected">@Html.ActionLink("Build", "Index")</li>    
+        <li>@Html.ActionLink("Edit", "Edit")</li>
+        <li>@Html.ActionLink("Status", "Index", "Status")</li>
+    </ul>
+}
Index: /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/_Layout.cshtml
===================================================================
--- /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/_Layout.cshtml	(revision 9214)
+++ /branches/OaaS/HeuristicLab.Services.Optimization.Web/Views/Shared/_Layout.cshtml	(revision 9215)
@@ -26,4 +26,8 @@
     <script type="text/javascript" src="@Url.Content("~/Content/jqplot/src/plugins/jqplot.donutRenderer.js")"></script>
     <script type="text/javascript" src="@Url.Content("~/Content/jqplot/src/plugins/jqplot.cursor.js")"></script>
+
+    <link href="@Url.Content("~/Content/dynatree/src/skin/ui.dynatree.css")" rel="stylesheet" type="text/css" />
+    <script type="text/javascript" src="@Url.Content("~/Content/dynatree/dist/jquery.dynatree.min.js")"></script>
+    <script type="text/javascript" src="@Url.Content("~/Content/ExperimentSupport.js")"></script>
 </head>
 <body>
@@ -40,6 +44,7 @@
         <div id="master-mainmenu">
             <ul id="menu">
-                <li>@Html.ActionLink("Admin", "Index", "Admin")</li>
                 <li>@Html.ActionLink("Home", "Index", "Home")</li>
+                <li>@Html.ActionLink("Experiment", "Index", "Experiment")</li>                
+                <li>@Html.ActionLink("Admin", "Index", "Admin")</li>                
                 <li>@Html.ActionLink("About", "About", "Home")</li>
             </ul>
@@ -47,5 +52,7 @@
         
         <div id="master-main">
-            <div id="master-submenu"/>
+            <div id="master-submenu">
+                @RenderSection("submenu", required: false)
+            </div>
             <div id="master-MainContent">                
                 @RenderBody()                
